package persistencia;

/**
 * Conexin a Bases de Datos.
 * @author  Giovanni Fajardo Utria.
 * @version 1.0.0
 */

import java.sql.*;

public class Sql
{
 // Atributos
    private String url, driver, user, password;
    private Connection connection;
    private ResultSet rst;
    private Statement statement;
    	
    /**
      * Contructor
      * @param url		URL
      * @param driver   Driver
      * @param usr      User
      * @param pswd		Password
     */ 
     
 //            "jdbc:odbc:" "JavaAccess"   ""           "password"   
	public Sql( String url,  String driver, String user, String password)
	{ this.url 		= url;
	  this.driver 	= driver;	
	  this.user 	= user;
	  this.password = password;	  
	  this.rst 		= null;
	  
      try
	   { // Instancia de una nueva clase para el puente
	 	 // sun.jdbc.odbc.JdbcOdbcDriver
	 	 // El puente sirve entre la aplicacin y el driver.
	    	Class.forName( "sun.jdbc.odbc.JdbcOdbcDriver" );
	   }
	   catch( ClassNotFoundException e )
	   { System.out.println( "Error al crear el puente JDBC-ODBC." ); }	  
	}


    /**
     * Obtiene una conexin con el nombre del driver especificado
     * @return connection Conexin con la base de datos.
     */
	public Connection makeConnection()
	{ this.url = this.url + this.driver;	  
	  try
	   { this.connection = DriverManager.getConnection( this.url, this.user, this.password ); }
	  catch(SQLException sqle)
	   { return null; }
	  return this.connection;
	}


    /**
     * Cierra la conexin.
     * @return boolean Retorna true si la conexin fue cerrada con exito.
     */
	public boolean closeConnection()
	{ try
	   { connection.close(); }
	  catch( SQLException sqle )
	   { return false; }
	  return true;
	}
		
	/**
	 * Utilizada para INSERT, UPDATE, o DELETE. 
	 * @param  sql
	 * @return reg Nmero de registros afectados.
	 */
	public int update( String sql ) throws SQLException
	{ this.statement  = this.connection.createStatement();
	  return statement.executeUpdate( sql );
	}		

	/**
	 * Retorna el resultado de la consulta ejecutada.
	 * @param  sql Consulta a realizar.
	 * @return rst Resultado de la consulta
	 */
	public ResultSet consult ( String sql ) throws SQLException
	{ this.statement  = this.connection.createStatement();
	  this.rst = statement.executeQuery( sql );
	  return rst;
	}		

}
